import { analyzeAndValidateNgModules } from '@angular/compiler';
import { Component, EventEmitter, Input, OnInit, Output } from '@angular/core';
import { ModalController, NavParams, PickerController, PopoverController } from '@ionic/angular';
import { ChatService } from 'src/app/services/chat.service';
import { GroupDurationPage } from 'src/app/shared/popover/group-duration/group-duration.page';
import { GroupContactsPage } from '../group-messages/group-contacts/group-contacts.page';

@Component({
  selector: 'app-new-group',
  templateUrl: './new-group.page.html',
  styleUrls: ['./new-group.page.scss'],
})
export class NewGroupPage implements OnInit {
  isGroupCreated:boolean;
  showLoader: boolean;
  displayDuration: any;
  showDuration: boolean;
  selectedDuration = ['','',''];
  //groupName:string;

  @Input() groupName:string;
  @Output() addGroupMessage:EventEmitter<any> = new EventEmitter<any>();

  constructor(
    private pickerController: PickerController,
    private popoverController: PopoverController,
    private modalController: ModalController,
    private chatService: ChatService,
    //private navParams: NavParams,
  ) 
  { 
    this.isGroupCreated = false;
    //this.groupName = this.navParams.get('name');
  }

  ngOnInit() {

  }
  _ionChange(event){
    this.showDuration = event.detail.checked;
  }
  close(){
    //this.modalController.dismiss();
    console.log('close');
    this.addGroupMessage.emit();
  }
  
  createGroup(){
    let name = this.groupName.split(' ').join('-');
    let body = { "name":name, }
    this.chatService.addGroup(body).subscribe(res=>{
      console.log('group created');
      console.log(res['group']);
      this.addGroupMessage.emit(res['group']._id);
    });
  }

  async addContacts(){
    this.close();

    let name = this.groupName.split(' ').join('-');
    console.log(name);
    
    const modal = await this.modalController.create({
      component: GroupContactsPage,
      componentProps: {
        isCreated:this.isGroupCreated,
        name: name,
        duration:'',
      }, 
      cssClass: 'contacts',
      backdropDismiss: false
    });

    await modal.present();
    modal.onDidDismiss();
  }
  
  async setDuration(ev: any) {
    const popover = await this.popoverController.create({
      component: GroupDurationPage,
      cssClass: 'group-duration',
      event: ev,
      translucent: true
    });
    return await popover.present();
  }

  async showPicker(){
    const picker = await this.pickerController.create({
      cssClass: '',
      buttons: [
          { 
            text: 'Cancelar', role: 'cancel', cssClass: 'btn-cancel'
          },
          { 
            text: 'Ok', 
            cssClass: 'btn-cancel',
            handler:(value:any)=>{
              console.log('button done pressed');
              this.selectedDuration = [
                value.days.value,
                value.hours.value,
                value.minutes.value,
              ]
              console.log(this.selectedDuration);
              if(value.days.value != null && value.hours.value != null && value.minutes.value != null){
                if(value.days.value > 0){
                  if(value.days.value == 1){
                    if(value.hours.value == 1){
                      this.displayDuration = value.days.value  + " day " +  
                      value.hours.value + " hora " +
                      value.minutes.value + " minutos";
                    }
                    else{
                      this.displayDuration = value.days.value  + " days " + 
                      value.hours.value + " horas " +
                      value.minutes.value + " minutos";
                    }
                  }
                  else{
                    if(value.hours.value == 1){
                      this.displayDuration = value.days.value  + " days " +  
                      value.hours.value + " hora " +
                      value.minutes.value + " minutos";
                    }
                    else{
                      this.displayDuration = value.days.value  + " days " + 
                      value.hours.value + " horas " +
                      value.minutes.value + " minutos";
                    }
                  }
                }
                else{
                  if(value.hours.value == 1){
                    this.displayDuration = value.hours.value + " hora " +
                    value.minutes.value + " minutos";
                  }
                  else{
                    this.displayDuration = value.hours.value + " horas " +
                    value.minutes.value + " minutos";
                  }
                }
              } 
            },
        },
      ],
      columns: [
        {
          name: 'days',
          prefix: 'Dias',
          options: [
            { text: '0', value: 0 },
            { text: '1', value: 1 },
            { text: '2', value: 2 },
            { text: '3', value: 3 },
            { text: '4', value: 4 },
          ]
        },
        {
          name: 'hours',
          prefix: 'Horas',
          options: [
            { text: '0', value: 0 },
            { text: '1', value: 1 },
            { text: '2', value: 2 },
            { text: '3', value: 3 },
            { text: '4', value: 4 },
            { text: '5', value: 5 },
            { text: '6', value: 6 },
            { text: '7', value: 7 },
            { text: '8', value: 8 },
          ]
        },
        {
          name: 'minutes',
          prefix: 'Minutos',
          selectedIndex: 3,
          options: [
            { text: '0', value: 0 },
            { text: '5', value: 5 },
            { text: '10', value: 10 },
            { text: '15', value: 15 },
            { text: '20', value: 20 },
            { text: '25', value: 25 },
            { text: '30', value: 30 },
            { text: '35', value: 35 },
            { text: '45', value: 45 },
            { text: '50', value: 50 },
            { text: '55', value: 55 },
          ]
        }
      ]
    });
    await picker.present();
    picker.onDidDismiss().then(async data =>{
      let day = await picker.getColumn('days');
      let hour = await picker.getColumn('hours'); 
      let minutes = await picker.getColumn('minutes');
    });

  }

}
